=== docs/requirements.txt ===
scipy
lxml
pytest
matplotlib
h5py
sphinx<1.8
sphinx-rtd-theme
sphinxcontrib-bibtex
sphinxcontrib-websupport
sphinx-bootstrap-theme
sphinxcontrib-napoleon
numpydoc
breathe
