=== debian/changelog ===
siconos (4.2.0+git20181026.0ee5349+dfsg.2-2) unstable; urgency=medium

  * Patch to fix ref filename for test SMCTest::SMCLsodar.
  * Add TwistingTest::test_ExplicitTwisting_Lsodar to list of broken tests.
  * Remove compiler paths and flags in installed CMakeLists.txt.
    (Closes: #940194)
  * Update to standards version 4.5.0, no changes necessary.
  * Update to debhelper compat 12, no changes necessary.
  * d/copyright: Add Upstream-Contact field.

 -- Stephen Sinclair <radarsat1@gmail.com>  Sun, 02 Feb 2020 20:12:40 +0000

siconos (4.2.0+git20181026.0ee5349+dfsg.2-1) unstable; urgency=medium

  * Initial release. (Closes: #915656)

 -- Stephen Sinclair <radarsat1@gmail.com>  Sat, 06 Apr 2019 18:47:19 +0000
